diff --git a/django/contrib/auth/__init__.py b/django/contrib/auth/__init__.py
index 232a822..2151a7a 100644
--- a/django/contrib/auth/__init__.py
+++ b/django/contrib/auth/__init__.py
@@ -1,6 +1,6 @@
 import datetime
 from warnings import warn
-from django.core.exceptions import ImproperlyConfigured
+from django.core.exceptions import ImproperlyConfigured, PermissionDenied
 from django.utils.importlib import import_module
 from django.contrib.auth.signals import user_logged_in, user_logged_out
 
@@ -56,6 +56,9 @@ def authenticate(**credentials):
         except TypeError:
             # This backend doesn't accept these credentials as arguments. Try the next one.
             continue
+        except PermissionDenied:
+            # This backend says to stop in our tracks - this user should not be allowed in at all.
+            return None
         if user is None:
             continue
         # Annotate the user object with the path of the backend.
diff --git a/django/contrib/auth/tests/__init__.py b/django/contrib/auth/tests/__init__.py
index 3a8f55b..fde134d 100644
--- a/django/contrib/auth/tests/__init__.py
+++ b/django/contrib/auth/tests/__init__.py
@@ -1,6 +1,7 @@
 from django.contrib.auth.tests.auth_backends import (BackendTest,
     RowlevelBackendTest, AnonymousUserBackendTest, NoAnonymousUserBackendTest,
-    NoBackendsTest, InActiveUserBackendTest, NoInActiveUserBackendTest)
+    NoBackendsTest, InActiveUserBackendTest, NoInActiveUserBackendTest,
+    PermissionDeniedBackendTest)
 from django.contrib.auth.tests.basic import BasicTestCase
 from django.contrib.auth.tests.decorators import LoginRequiredTestCase
 from django.contrib.auth.tests.forms import (UserCreationFormTest,
diff --git a/django/contrib/auth/tests/auth_backends.py b/django/contrib/auth/tests/auth_backends.py
index 256357a..51fd069 100644
--- a/django/contrib/auth/tests/auth_backends.py
+++ b/django/contrib/auth/tests/auth_backends.py
@@ -3,7 +3,8 @@ import warnings
 from django.conf import settings
 from django.contrib.auth.models import User, Group, Permission, AnonymousUser
 from django.contrib.contenttypes.models import ContentType
-from django.core.exceptions import ImproperlyConfigured
+from django.core.exceptions import ImproperlyConfigured, PermissionDenied
+from django.contrib.auth import authenticate
 from django.test import TestCase
 
 
@@ -354,3 +355,35 @@ class NoInActiveUserBackendTest(TestCase):
         self.assertEqual(self.user1.has_module_perms("app1"), False)
         self.assertEqual(self.user1.has_module_perms("app2"), False)
 
+class PermissionDeniedBackend(object):
+    """
+    always raises PermissionDenied
+    """
+    supports_object_permissions = False
+    supports_anonymous_user = False
+
+    def authenticate(self, username=None, password=None):
+        raise PermissionDenied
+
+class PermissionDeniedBackendTest(TestCase):
+    """
+        Tests that other backends are not checked once a backend raises PermissionDenied
+    """
+    backend = 'django.contrib.auth.tests.auth_backends.PermissionDeniedBackend'
+
+    def setUp(self):
+        self.curr_auth = settings.AUTHENTICATION_BACKENDS
+        self.user1 = User.objects.create_user('test', 'test@example.com', 'test')
+        self.user1.save()
+
+    def tearDown(self):
+        settings.AUTHENTICATION_BACKENDS = self.curr_auth
+
+    def test_permission_denied(self):
+        "user is not authenticated after a backend raises permission denied #2550"
+        settings.AUTHENTICATION_BACKENDS = (self.backend,) + tuple(self.curr_auth)
+        self.assertEqual(authenticate(username='test', password='test'), None)
+
+    def test_authenticates(self):
+        settings.AUTHENTICATION_BACKENDS = tuple(self.curr_auth) + (self.backend,)
+        self.assertEqual(authenticate(username='test', password='test'), self.user1)
diff --git a/docs/topics/auth.txt b/docs/topics/auth.txt
index 52ddf22..96cf0d8 100644
--- a/docs/topics/auth.txt
+++ b/docs/topics/auth.txt
@@ -1508,6 +1508,12 @@ processing at the first positive match.
     you need to force users to re-authenticate using different methods. A simple
     way to do that is simply to execute ``Session.objects.all().delete()``.
 
+.. versionadded:: 1.4
+
+If a backend raises a :class:`~django.core.exceptions.PermissionDenied`
+exception, authentication will immediately fail. Django won't check the backends that follow.
+
+
 Writing an authentication backend
 ---------------------------------
 